﻿#region License
/*
 * Copyright ©2010-2011 Doca Labs Project
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *  
 */
#endregion

using System.Threading.Tasks;
using DocaAzure.Backup.Interfaces;
using NUnit.Framework;

namespace DocaAzure.Backup.Cmdlets.IntegrationTests
{
    [TestFixture]
    public class RestoreContainerTests
    {
        [TearDown]
        public void TearDown()
        {
            Utils.DeleteQueue();
        }

        [Test]
        public void InitiatesContainerRestore()
        {
            Utils.RecreateQueue();

            var cmd = new RestoreContainer
            {
                BaseContainer = "MyContainer",
                StorageAccountConnectionString = "UseDevelopmentStorage=true",
                MaxDegreeOfParallelism = 4
            };

            var e = cmd.Invoke().GetEnumerator();

            // this will actually call ProcessRecord() 
            e.MoveNext();

            var result = e.Current as Task<MonitoringResults>;

            Assert.IsNotNull(result);
            Assert.IsFalse(result.IsCompleted, "as the bus is mocked the messages won't be processed");

            // assert that the message was sent
            Assert.IsNotNull(Utils.TryGetMessage());
        }
    }
}
