﻿#region License
/*
 * Copyright ©2010-2011 Doca Labs Project
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *  
 */
#endregion

using System;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace DocaAzure.Backup.Cmdlets.IntegrationTests
{
    internal static class Utils
    {
        public const string DefaultTestQueueName = "integrationtestqueue";

        public static void RecreateQueue()
        {
            var queue = CloudStorageAccount.DevelopmentStorageAccount.CreateCloudQueueClient().GetQueueReference(DefaultTestQueueName);

            try
            {
                queue.Delete();
            }
// ReSharper disable EmptyGeneralCatchClause
            catch
// ReSharper restore EmptyGeneralCatchClause
            {
                
            }

            queue.CreateIfNotExist();
        }

        public static void DeleteQueue()
        {
            var queue = CloudStorageAccount.DevelopmentStorageAccount.CreateCloudQueueClient().GetQueueReference(DefaultTestQueueName);

            try
            {
                queue.Delete();
            }
// ReSharper disable EmptyGeneralCatchClause
            catch
// ReSharper restore EmptyGeneralCatchClause
            {
            }
        }

        public static CloudQueueMessage TryGetMessage()
        {
            var queue = CloudStorageAccount.DevelopmentStorageAccount.CreateCloudQueueClient().GetQueueReference(DefaultTestQueueName);

            return queue.GetMessage(TimeSpan.FromMilliseconds(10));
        }
    }
}
