﻿#region License
/*
 * Copyright ©2010-2011 Doca Labs Project
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *  
 */
#endregion

using System;
using System.IO;

namespace DocaAzure.Backup.Interfaces
{
    /// <summary>
    /// Defines interface for table backup writers
    /// </summary>
    public interface ITableBackupWriter : IDisposable
    {
        /// <summary>
        /// Add a new block to the blob
        /// </summary>
        /// <param name="blockId">Blovk id</param>
        /// <param name="dataStream">Stream with data</param>
        void AddBlock(string blockId, Stream dataStream);

        /// <summary>
        /// Finilize the blob were will not be any new block added
        /// </summary>
        void FinalizeBlob();
    }
}
